<?php
/*------------------------------------------------------------------------
# JoomSport Professional 
# ------------------------------------------------------------------------
# BearDev development company 
# Copyright (C) 2011 JoomSport.com. All Rights Reserved.
# @license - http://joomsport.com/news/license.html GNU/GPL
# Websites: http://www.JoomSport.com 
# Technical Support:  Forum - http://joomsport.com/helpdesk/
-------------------------------------------------------------------------*/
// No direct access.
defined('_JEXEC') or die;

require dirname(__FILE__).'/../models.php';

class match_editJSModel extends JSPRO_Models
{
    public $_data = null;
    public $_lists = null;
    public $_mode = 1;
    public $_id = null;
    public $s_id = null;
    public function __construct()
    {
        parent::__construct();

        $this->getData();
    }

    public function getData()
    {
        $cid = JRequest::getVar('cid', array(0), '', 'array');
        $is_id = (int) $cid[0];

        if (!$is_id) {
            return false;
        }

        $row = new JTableMatch($this->db);
        $row->load($is_id);
        $error = $this->db->getErrorMsg();
        if ($error) {
            return JError::raiseError(500, $error);
        }

        $query = 'SELECT s_id FROM #__bl_matchday  WHERE id = '.$row->m_id;
        $this->db->setQuery($query);
        $season_id = $this->db->loadResult();
        $error = $this->db->getErrorMsg();
        if ($error) {
            return JError::raiseError(500, $error);
        }

        $this->s_id = $season_id;

        $this->_lists['t_type'] = $this->getMatchDayType($row);

        if ($season_id != -1) {
            $tourn = $this->getSeasAttr($season_id);

            $this->_lists['t_single'] = $tourn->t_single;
            //$this->_lists['t_type'] = $tourn->t_type;
            $this->_lists['t_type'] = $this->getMatchDayType($row);
            $this->_lists['s_enbl_extra'] = $tourn->s_enbl_extra;
        } else {
            $tourn = new stdClass();
            $this->_lists['t_type'] = 0;
            $this->_lists['s_enbl_extra'] = 0;
            //$tourn->t_type=0;
            if ($row->m_single == 1) {
                $tourn->t_single = 1;
                $this->_lists['t_single'] = 1;
            } else {
                $tourn->t_single = 0;
                $this->_lists['t_single'] = 0;
            }

            $tourn->s_enbl_extra = 0;
        }

        if ($this->_lists['t_type'] == 1 || $this->_lists['t_type'] == 2 || $this->_lists['t_type'] == 3) {
            $query = 'SELECT m_name FROM #__bl_matchday  WHERE id = '.$row->m_id;
            $this->db->setQuery($query);
            $this->_lists['mday'] = $this->db->loadResult();
        } else {
            $is_matchday = array();
            $query = 'SELECT * FROM #__bl_matchday  WHERE s_id = '.$season_id.' ORDER BY m_name';
            $this->db->setQuery($query);
            $mday = $this->db->loadObjectList();
            $is_matchday[] = JHTML::_('select.option',  0, JText::_('BLBE_SELMATCHDAY'), 'id', 'm_name');
            if (count($mday)) {
                $mdayis = array_merge($is_matchday, $mday);
            }
            $this->_lists['mday'] = JHTML::_('select.genericlist',   $mdayis, 'm_id', 'class="chzn-done" size="1"', 'id', 'm_name', $row->m_id);
        }

        $this->getPlEvent();
        $this->getTeamEvent();

        if ($tourn->t_single) {
            $query = "SELECT CONCAT(first_name,' ',last_name) FROM #__bl_players WHERE id= ".$row->team1_id;
            $this->db->setQuery($query);
            $team_1 = $this->db->loadResult();

            $query = "SELECT CONCAT(first_name,' ',last_name) FROM #__bl_players WHERE id= ".$row->team2_id;
            $this->db->setQuery($query);
            $team_2 = $this->db->loadResult();
        } else {
            $query = 'SELECT t_name FROM #__bl_teams WHERE id= '.$row->team1_id;
            $this->db->setQuery($query);
            $team_1 = $this->db->loadResult();

            $query = 'SELECT t_name FROM #__bl_teams WHERE id= '.$row->team2_id;
            $this->db->setQuery($query);
            $team_2 = $this->db->loadResult();
        }

        $this->_lists['teams1'] = $team_1;
        $this->_lists['teams2'] = $team_2;
        $is_player = array();
        if ($tourn->t_single) {
            $is_player[] = JHTML::_('select.option',  0, JText::_('BLBE_SELPLAYER'), 'id', 'p_name');
            if ($row->team1_id != -1) {
                $is_player[] = JHTML::_('select.option',  $row->team1_id, $team_1, 'id', 'p_name');
            }
            if ($row->team2_id != -1) {
                $is_player[] = JHTML::_('select.option',  $row->team2_id, $team_2, 'id', 'p_name');
            }
            $ev_pl = $is_player;
            $this->_lists['players'] = JHTML::_('select.genericlist',   $ev_pl, 'playerz_id', 'class="chzn-done" size="1" style="width:190px;"', 'id', 'p_name', 0);
        } else {
            $query = "SELECT CONCAT(p.id,'*',s.team_id) as id,CONCAT(p.first_name,' ',p.last_name) as p_name,p.id as pid
			            FROM #__bl_players as p, #__bl_players_team as s
			            WHERE s.confirmed='0' AND s.player_join='0' AND s.player_id = p.id
			            AND s.team_id = ".$row->team1_id.' AND s.season_id='.$season_id
                        .' ORDER BY p.first_name,p.last_name';
            if ($season_id == -1) {
                $query = "SELECT DISTINCT(p.id),p.id as id,
				            CONCAT(p.first_name,' ',p.last_name) as p_name,p.id as pid
				            FROM #__bl_players as p, #__bl_players_team as s
				            WHERE s.confirmed='0' AND s.player_join='0' AND s.player_id = p.id
				            ORDER BY p.first_name,p.last_name";
            }
            $this->db->setQuery($query);

            $players_1 = $this->_lists['team1_players'] = $this->db->loadObjectList();

        //--	
            $mjarr1 = array(-1);
            for ($i = 0; $i < count($players_1);++$i) {
                $mjarr1[] = $players_1[$i]->pid;
            }

            $query = "SELECT CONCAT(p.id,'*',s.team_id) as id,"
                        ." CONCAT(p.first_name,' ',p.last_name) as p_name, p.id as pid"
                        .' FROM #__bl_players as p, #__bl_squard as s'
                        .' WHERE s.player_id NOT IN('.implode(',', $mjarr1).') AND p.id=s.player_id'
                        ." AND s.match_id='".$row->id."' AND s.team_id='".$row->team1_id."'"
                        .' ORDER BY p.first_name,p.last_name';
            $this->db->setQuery($query);
            $squard1 = $this->db->loadObjectList();

            if (count($squard1)) {
                $players_1 = array_merge($players_1, $squard1);
            }
        //--
            $query = "SELECT CONCAT(p.id,'*',s.team_id) as id,"
                        ." CONCAT(p.first_name,' ',p.last_name) as p_name,p.id as pid"
                        .' FROM #__bl_players as p, #__bl_players_team as s'
                        ." WHERE s.confirmed='0' AND s.player_join='0' AND s.player_id = p.id"
                        .' AND s.team_id = '.$row->team2_id.' AND s.season_id='.$season_id
                        .' ORDER BY p.first_name,p.last_name';
            if ($season_id == -1) {
                $query = 'SELECT DISTINCT(p.id),p.id as id,'
                        ." CONCAT(p.first_name,' ',p.last_name) as p_name,p.id as pid"
                        .' FROM #__bl_players as p, #__bl_players_team as s '
                        ." WHERE s.confirmed='0' AND s.player_join='0' AND s.player_id = p.id"
                        .' ORDER BY p.first_name,p.last_name';
            }
            $this->db->setQuery($query);

            $players_2 = $this->_lists['team2_players'] = $this->db->loadObjectList();
        //--	
            $mjarr2 = array(-1);
            for ($i = 0; $i < count($players_2);++$i) {
                $mjarr2[] = $players_2[$i]->pid;
            }

            $query = "SELECT CONCAT(p.id,'*',s.team_id) as id,CONCAT(p.first_name,' ',p.last_name) as p_name, p.id as pid"
                        .' FROM #__bl_players as p, #__bl_squard as s'
                        .' WHERE s.player_id NOT IN('.implode(',', $mjarr2).') AND p.id=s.player_id'
                        ." AND s.match_id='".$row->id."' AND s.team_id='".$row->team2_id."'"
                        .' ORDER BY p.first_name,p.last_name';
            $this->db->setQuery($query);
            $squard2 = $this->db->loadObjectList();

            if (count($squard2)) {
                $players_2 = array_merge($players_2, $squard2);
            }
        //--
            $is_player[] = JHTML::_('select.option',  0, JText::_('BLBE_SELPLAYER'), 'id', 'p_name');

            $is_player[] = JHTML::_('select.optgroup',  $team_1, 'id', 'p_name');

            $is_player2[] = JHTML::_('select.optgroup',  $team_2, 'id', 'p_name');

            $jqre = '<select name="playerz_id" id="playerz_id" style="width:190px;" class="chzn-done" size="1">';
            $jqre .= '<option value="0">'.JText::_('BLBE_SELPLAYER').'</option>';
            $jqre .= '<optgroup label="'.$team_1.'">';
            for ($g = 0;$g < count($players_1);++$g) {
                $jqre .= '<option value="'.$players_1[$g]->id.'*'.$row->team1_id.'">'.$players_1[$g]->p_name.'</option>';
            }
            $jqre .= '</optgroup>';
            $jqre .= '<optgroup label="'.$team_2.'">';
            for ($g = 0;$g < count($players_2);++$g) {
                $jqre .= '<option value="'.$players_2[$g]->id.'*'.$row->team2_id.'">'.$players_2[$g]->p_name.'</option>';
            }
            $jqre .= '</optgroup>';
            $jqre .= '</select>';

            $this->_lists['players'] = $jqre;
        }

        if (!$tourn->t_single) {
            $this->_lists['pl1'] = $players_1;
            $is_player_sq[] = JHTML::_('select.option',  0, JText::_('BLBE_SELPLAYER'), 'pid', 'p_name');

            $query = "SELECT p.id as pid, CONCAT(p.first_name,' ',p.last_name) as p_name"
                                .' FROM #__bl_players as p'
                                .' JOIN #__bl_squard as s ON p.id = s.player_id'
                                .' WHERE s.team_id='.intval($row->team1_id).' AND s.match_id = '.intval($row->id)
                                ." AND s.mainsquard = '1' AND s.accepted = '1'";
            $this->db->setQuery($query);
            $players_1_main = $this->db->loadObjectList();

            if (count($players_1_main)) {
                $ev_pl = array_merge($is_player_sq, $players_1_main);
            } else {
                $ev_pl = $is_player_sq;
            }
            $this->_lists['players_team1'] = JHTML::_('select.genericlist',   $ev_pl, 'playersq1_id', 'class="inputbox chzn-done" size="1" style="width:150px;"', 'pid', 'p_name', 0);

            $query = "SELECT p.id as pid, CONCAT(p.first_name,' ',p.last_name) as p_name"
                                .' FROM #__bl_players as p'
                                .' JOIN #__bl_squard as s ON p.id = s.player_id'
                                .' WHERE s.team_id='.intval($row->team1_id).' AND s.match_id = '.intval($row->id)
                                ." AND s.mainsquard = '0' AND s.accepted = '1'";
            $this->db->setQuery($query);
            $players_1_subs = $this->db->loadObjectList();

            if (count($players_1_subs)) {
                $ev_pl = array_merge($is_player_sq, $players_1_subs);
            } else {
                $ev_pl = $is_player_sq;
            }
            $this->_lists['players_team1_out'] = JHTML::_('select.genericlist',   $ev_pl, 'playersq1_out_id', 'class="inputbox chzn-done" size="1" style="width:150px;"', 'pid', 'p_name', 0);

            $this->_lists['pl2'] = $players_2;

            $this->_lists['players_team1_res'] = JHTML::_('select.genericlist',   $ev_pl, 'playersq1_id_res', 'class="inputbox chzn-done" size="1" style="width:150px;"', 'pid', 'p_name', 0);

            $query = "SELECT p.id as pid, CONCAT(p.first_name,' ',p.last_name) as p_name"
                                .' FROM #__bl_players as p'
                                .' JOIN #__bl_squard as s ON p.id = s.player_id'
                                .' WHERE s.team_id='.intval($row->team2_id).' AND s.match_id = '.intval($row->id)
                                ." AND s.mainsquard = '1' AND s.accepted = '1'";
            $this->db->setQuery($query);
            $players_2_main = $this->db->loadObjectList();

            if (count($players_2_main)) {
                $ev_pl = array_merge($is_player_sq, $players_2_main);
            } else {
                $ev_pl = $is_player_sq;
            }
            $this->_lists['players_team2'] = JHTML::_('select.genericlist',   $ev_pl, 'playersq2_id', 'class="inputbox chzn-done" size="1" style="width:150px;"', 'pid', 'p_name', 0);

            $query = "SELECT p.id as pid, CONCAT(p.first_name,' ',p.last_name) as p_name"
                                .' FROM #__bl_players as p'
                                .' JOIN #__bl_squard as s ON p.id = s.player_id'
                                .' WHERE s.team_id='.intval($row->team2_id).' AND s.match_id = '.intval($row->id)
                                ." AND s.mainsquard = '0' AND s.accepted = '1'";
            $this->db->setQuery($query);
            $players_2_subs = $this->db->loadObjectList();

            if (count($players_2_subs)) {
                $ev_pl = array_merge($is_player_sq, $players_2_subs);
            } else {
                $ev_pl = $is_player_sq;
            }
            $this->_lists['players_team2_out'] = JHTML::_('select.genericlist',   $ev_pl, 'playersq2_out_id', 'class="inputbox chzn-done" size="1" style="width:150px;"', 'pid', 'p_name', 0);

            //$this->_lists['players_team2'] = JHTML::_('select.genericlist',   $ev_pl, 'playersq2_id', 'class="inputbox chzn-done" size="1" style="width:150px;"', 'pid', 'p_name', 0);
            //$this->_lists['players_team2_out'] = JHTML::_('select.genericlist',   $ev_pl, 'playersq2_out_id', 'class="inputbox chzn-done" size="1" style="width:150px;"', 'pid', 'p_name', 0);

            $this->_lists['players_team2_res'] = JHTML::_('select.genericlist',   $ev_pl, 'playersq2_id_res', 'class="inputbox chzn-done" size="1" style="width:150px;"', 'pid', 'p_name', 0);
        }

        $is_team[] = JHTML::_('select.option',  0, JText::_('BLBE_SELTEAM'), 'id', 'p_name');
        if ($row->team1_id != -1) {
            $is_team[] = JHTML::_('select.option', $row->team1_id, $team_1, 'id', 'p_name');
        }
        if ($row->team2_id != -1) {
            $is_team[] = JHTML::_('select.option', $row->team2_id, $team_2, 'id', 'p_name');
        }
        //$is2_player[] = '</optgroup>';$lists['players']
        $this->_lists['sel_team'] = JHTML::_('select.genericlist',   $is_team, 'teamz_id', 'class="inputbox chzn-done" size="1" style="width:190px;"', 'id', 'p_name', 0);
        $javascriptus = ($this->_lists['t_type'] > 0) ? ' onclick="javascript:chng_disbl_aet();"' : '';
        $this->_lists['extra'] = JHTML::_('select.booleanlist',  'is_extra', 'class="inputbox chzn-done" '.$javascriptus, $row->is_extra);
        $this->_lists['is_extra'] = $row->is_extra;//UPDATE
        $js = 'onclick="enblnp();"';
        $this->_lists['new_points'] = JHTML::_('select.booleanlist',  'new_points', 'class="inputbox" '.$js, $row->new_points);
        $this->_lists['m_played'] = $this->getMatchStatuses($row->m_played, 'm_played');
                //$this->_lists['m_played'] 		= JHTML::_('select.booleanlist',  'm_played', 'class="inputbox"', $row->m_played );

        $pl_list = $this->_lists['t_single'] ? array($row->team1_id, $row->team2_id) : array_merge($mjarr1, $mjarr2);
        $query = "SELECT me.*,ev.e_name,CONCAT(p.first_name,' ',p.last_name) as p_name"
                    .' FROM  #__bl_events as ev , #__bl_players as p, #__bl_match_events as me'
                    ." WHERE me.player_id = p.id AND ev.player_event = '1'"
                    .' AND  me.e_id = ev.id AND me.match_id = '.$row->id
                    .' '.(count($pl_list) ? 'AND me.player_id IN('.implode(',', $pl_list).')' : '').' ORDER BY me.eordering, CAST(me.minutes AS UNSIGNED),p.first_name,p.last_name';
        $this->db->setQuery($query);
        $this->_lists['m_events'] = $this->db->loadObjectList();
//update

        $t_list = !$this->_lists['t_single'] ? array($row->team1_id, $row->team2_id) : array();
        $query = 'SELECT me.*,ev.e_name,p.t_name as p_name,p.id as pid'
                    .' FROM  #__bl_events as ev, #__bl_teams as p , #__bl_match_events as me'
                    ." WHERE me.t_id = p.id AND ev.player_event = '0' AND  me.e_id = ev.id AND me.match_id = ".$row->id.'  '.(count($t_list) ? 'AND me.t_id IN('.implode(',', $t_list).')' : '')
                    .' ORDER BY me.eordering,p.t_name';
        $this->db->setQuery($query);
        //echo mysql_error();die();
        $this->_lists['t_events'] = $this->db->loadObjectList();

        $this->_lists['photos'] = $this->getPhotos(3, $row->id);

        ///-----EXTRAFIELDS---//
        $this->_lists['ext_fields'] = $this->getAdditfields(2, $row->id);

        ///--------MAPS--------------///
        $query = 'SELECT m.*,mp.m_score1,mp.m_score2'
                .' FROM #__bl_seas_maps as sm, #__bl_maps as m '
                .' LEFT JOIN #__bl_mapscore as mp ON m.id=mp.map_id AND mp.m_id='.$row->id
                .' WHERE m.id=sm.map_id AND sm.season_id='.$season_id
                .' ORDER BY m.id';
        $this->db->setQuery($query);
        $this->_lists['maps'] = $this->db->loadObjectList();

        //----squard----//

        $query = 'SELECT p.id FROM #__bl_players as p, #__bl_squard as s '
                .' WHERE p.id=s.player_id AND s.match_id='.$row->id." AND s.team_id={$row->team1_id}"
                ." AND s.mainsquard = '1'";
        $this->db->setQuery($query);
        $this->_lists['squard1'] = $this->db->loadColumn();
        $query = 'SELECT p.id FROM #__bl_players as p, #__bl_squard as s '
                .' WHERE p.id=s.player_id AND s.match_id='.$row->id
                ." AND s.team_id={$row->team2_id} AND s.mainsquard = '1'";
        $this->db->setQuery($query);
        $this->_lists['squard2'] = $this->db->loadColumn();
        $query = 'SELECT p.id FROM #__bl_players as p, #__bl_squard as s WHERE p.id=s.player_id AND s.match_id='.$row->id." AND s.team_id={$row->team1_id} AND s.mainsquard = '0'";
        $this->db->setQuery($query);
        $this->_lists['squard1_res'] = $this->db->loadColumn();
        $query = 'SELECT p.id FROM #__bl_players as p, #__bl_squard as s WHERE p.id=s.player_id AND s.match_id='.$row->id." AND s.team_id={$row->team2_id} AND s.mainsquard = '0'";
        $this->db->setQuery($query);
        $this->_lists['squard2_res'] = $this->db->loadColumn();
        //subs in
        $query = "SELECT s.*,CONCAT(p1.first_name,' ',p1.last_name) as plin,CONCAT(p2.first_name,' ',p2.last_name) as plout"
                . " FROM #__bl_subsin as s"
                . " JOIN #__bl_players as p2 ON p2.id=s.player_out"
                . " LEFT JOIN #__bl_players as p1 ON p1.id=s.player_in"
                . " WHERE s.match_id=".$row->id." AND s.team_id={$row->team1_id}"
                . " ORDER BY s.minutes";
        $this->db->setQuery($query);
        $this->_lists['subsin1'] = $this->db->loadObjectList();
        $query = "SELECT s.*,CONCAT(p1.first_name,' ',p1.last_name) as plin,CONCAT(p2.first_name,' ',p2.last_name) as plout"
                . " FROM #__bl_subsin as s"
                . " JOIN #__bl_players as p2 ON p2.id=s.player_out"
                . " LEFT JOIN #__bl_players as p1 ON p1.id=s.player_in"
                . " WHERE s.match_id=".$row->id." AND s.team_id={$row->team2_id}"
                . " ORDER BY s.minutes";
        $this->db->setQuery($query);
        $this->_lists['subsin2'] = $this->db->loadObjectList();

        //venue
                $this->_lists['unbl_venue'] = $this->getJS_Config('unbl_venue');
        $is_venue[] = JHTML::_('select.option',  0, JText::_('BLBE_SELVENUE'), 'id', 'v_name');
        $query = 'SELECT * FROM #__bl_venue ORDER BY v_name';
        $this->db->setQuery($query);
        $venue = $this->db->loadObjectList();
        if (count($venue)) {
            $is_venue = array_merge($is_venue, $venue);
        }
        $this->_lists['venue'] = JHTML::_('select.genericlist',   $is_venue, 'venue_id', 'class="chzn-done" size="1"', 'id', 'v_name', $row->venue_id);
        $this->_lists['post_max_size'] = $this->getValSettingsServ('post_max_size');
        //time line options
        $this->_lists['jstimeline'] = $this->getJS_Config('jstimeline');
        if (!$tourn->t_single) {
        $this->_lists['boxhtml'] = $this->getBoxStat($row);
        }
        
        $this->_data = $row;
        $this->_lists['languages'] = $this->getLanguages();
        $this->_lists['translation'] = array();
        if(count($this->_lists['languages']) && $row->id){
            $this->_lists['translation'] = $this->getTranslation('match_'.$row->id);
           
        }
        
        
        $query = 'SELECT *'
                    .' FROM  #__bl_events'
                    ." WHERE player_event = '0'"
                    .' ORDER BY ordering,e_name';
        $this->db->setQuery($query);
        //echo mysql_error();die();
        $teamEv = array();
        $all_team_events = $this->db->loadObjectList();
        for($intA=0;$intA<count($all_team_events);$intA++){
            $query = 'SELECT me.ecount'
                    .' FROM  #__bl_match_events as me'
                    ." WHERE me.t_id = ".$row->team1_id." AND  me.e_id = ".$all_team_events[$intA]->id." AND me.match_id = ".$row->id;
            $this->db->setQuery($query);
            $hcount = $this->db->loadResult();
            if($hcount !== null && intval($hcount)){
                $all_team_events[$intA]->home = $hcount;
            }
            
            $query = 'SELECT me.ecount'
                    .' FROM  #__bl_match_events as me'
                    ." WHERE me.t_id = ".$row->team2_id." AND  me.e_id = ".$all_team_events[$intA]->id." AND me.match_id = ".$row->id;
            $this->db->setQuery($query);
            $hcount = $this->db->loadResult();
            if($hcount !== null && intval($hcount)){
                $all_team_events[$intA]->away = $hcount;
            }
            $teamEv[] = $all_team_events[$intA];
        }
        
        $this->_lists['team_events_list'] = $teamEv;
        
    }
    protected function getMatchDayType($row)
    {
        $query = 'SELECT t_type FROM #__bl_matchday WHERE id='.$row->m_id;
        $this->db->setQuery($query);

        return $t_type = $this->db->loadResult();
    }
    protected function getPlEvent()
    {
        $is_event = array();
        $query = "SELECT * FROM #__bl_events WHERE player_event = '1' ORDER BY e_name";
        $this->db->setQuery($query);
        $events = $this->db->loadObjectList();
        $is_event[] = JHTML::_('select.option',  0, JText::_('BLBE_SELEVENT'), 'id', 'e_name');
        if (count($events)) {
            $is_event = array_merge($is_event, $events);
        }
        $this->_lists['events'] = JHTML::_('select.genericlist',   $is_event, 'event_id', 'class="inputbox chzn-done" size="1" style="width:170px;"', 'id', 'e_name', 0);
    }

    protected function getTeamEvent()
    {
        $is_event = array();
        $query = "SELECT * FROM #__bl_events WHERE player_event = '0' ORDER BY e_name";
        $this->db->setQuery($query);
        $events = $this->db->loadObjectList();
        $this->_lists['team_events_count'] = count($events);
        $is_event[] = JHTML::_('select.option',  0, JText::_('BLBE_SELEVENT'), 'id', 'e_name');
        if (count($events)) {
            $is_event = array_merge($is_event, $events);
        }
        $this->_lists['team_events'] = JHTML::_('select.genericlist',   $is_event, 'tevent_id', 'class="inputbox chzn-done" size="1" style="width:170px;"', 'id', 'e_name', 0);
    }

    public function saveMatch()
    {
        if (!JFactory::getUser()->authorise('core.edit', 'com_joomsport')) {
            return JError::raiseError(303, '');
        }
        $mainframe = JFactory::getApplication();
        $post = JRequest::get('post');
        $post['match_descr'] = JRequest::getVar('match_descr', '', 'post', 'string', JREQUEST_ALLOWRAW);
        $row = new JTableMatch($this->db);
        $row->m_date = JRequest::getVar('m_date', '', 'post', 'string', JREQUEST_ALLOWRAW);
        $row->m_time = JRequest::getVar('d_time', '', 'post', 'string', JREQUEST_ALLOWRAW);
        $moptions = JRequest::getVar('moptions', array(), 'post', 'array');
        $row->options = json_encode($moptions);
        
        if(isset($_POST['knteamid']) && count($_POST['knteamid'])){
            $row->team1_id =  intval($_POST['knteamid'][0]);
            $row->team2_id =  intval($_POST['knteamid'][1]);
            unset($post['team1_id']);
            unset($post['team2_id']);
            if(isset($_POST['knteamscore']) && count($_POST['knteamscore'])){
                $row->score1 =   intval($_POST['knteamscore'][0]);
                $row->score2 =  intval($_POST['knteamscore'][1]);
            }
        }
        
        $row_prev = new JTableMatch($this->db);
        $row_prev->load(intval($_POST["id"]));
        $score1_prev = $row_prev->score1;
        $score2_prev = $row_prev->score2;
        
        if (!$row->bind($post)) {
            JError::raiseError(500, $row->getError());
        }
        if (isset($_POST['penwin']) && count($_POST['penwin'])) {
            //var_dump($_POST['penwin']);die();
            $row->p_winner = intval($_POST['penwin'][0]);
        } else {
            $row->p_winner = 0;
        }
        if (!$row->check()) {
            JError::raiseError(500, $row->getError());
        }
            // if new item order last in appropriate group
            if (!$row->store()) {
                JError::raiseError(500, $row->getError());
            }
        $row->checkin();

        require_once 'components/com_joomsport/helpers/images.php';
        $default_id = ImagesHelper::saveImgs($_POST['jsgallery'], $row->id, 3);
                //$row->def_img = $default_id;
                $row->store();

        $query = 'SELECT s_id FROM #__bl_matchday as md, #__bl_match as m  WHERE md.id=m.m_id AND m.id = '.$row->id;
        $this->db->setQuery($query);
        $season_id = $this->db->loadResult();

        $tourn = $this->getSeasAttr($season_id);

        $lt_type = $this->_lists['t_type'];

        $row->load($row->id);

        $this->db->setQuery("SELECT id, player_event FROM #__bl_box_fields WHERE complex='0' AND ftype = '2' AND player_event > 0");
        $event_box_fields_ = $this->db->loadObjectList();
        $event_box_fields = [];
        foreach($event_box_fields_ as $item) {
            $event_box_fields[$item->player_event] = $item->id;
        }
        $events_boxFields = array_keys($event_box_fields);
        $event_box_data = [];
        
        if ($lt_type == 1 || $lt_type == 2) {
            $team_win = ($row->score1 > $row->score2) ? $row->team1_id : $row->team2_id;
            $team_loose = ($row->score1 > $row->score2) ? $row->team2_id : $row->team1_id;
            if (!empty($row->p_winner)) {
                $team_win = ($row->p_winner == $row->team1_id) ? $row->team1_id : $row->team2_id;
                $team_loose = ($team_win == $row->team1_id) ? $row->team2_id : $row->team1_id;
            }

            if ($row->is_extra) {
                $team_win = ($row->aet1 > $row->aet2) ? $row->team1_id : $row->team2_id;
                $team_loose = ($row->aet1 > $row->aet2) ? $row->team2_id : $row->team1_id;
            }

            $query = 'UPDATE #__bl_match SET team1_id='.$team_win.'  WHERE m_id = '.$row->m_id.' AND k_stage > '.$row->k_stage.' AND team1_id = '.$team_loose;
            $this->db->setQuery($query);
            $this->db->query();
            $query = 'UPDATE #__bl_match SET team2_id='.$team_win.'  WHERE m_id = '.$row->m_id.' AND k_stage > '.$row->k_stage.' AND team2_id = '.$team_loose;
            $this->db->setQuery($query);
            $this->db->query();

            if ($row->m_played == 0) {
                $query = "UPDATE #__bl_match SET m_played = '0' WHERE m_id = ".$row->m_id.' AND k_stage > '.$row->k_stage.' AND (team1_id = '.$row->team1_id.' OR team2_id = '.$row->team1_id.' OR team1_id = '.$row->team2_id.' OR team2_id = '.$row->team2_id.')';
                $this->db->setQuery($query);
                $this->db->query();
                $query = "UPDATE #__bl_match SET team1_id = '0' WHERE m_id = ".$row->m_id.' AND k_stage > '.$row->k_stage.' AND (team1_id = '.$row->team1_id.' OR team1_id = '.$row->team2_id.')';
                $this->db->setQuery($query);
                $this->db->query();
                $query = "UPDATE #__bl_match SET team2_id = '0' WHERE m_id = ".$row->m_id.' AND k_stage > '.$row->k_stage.' AND (team2_id = '.$row->team1_id.' OR team2_id = '.$row->team2_id.')';
                $this->db->setQuery($query);
                $this->db->query();
            }
        }

        $eordering = 0;
        $me_arr = array();
        if (isset($_POST['new_eventid']) && count($_POST['new_eventid'])) {
            for ($i = 0; $i < count($_POST['new_eventid']); ++$i) {
                if (!intval($_POST['em_id'][$i])) {
                    $new_event = $_POST['new_eventid'][$i];

                    $plis = explode('*', $_POST['new_player'][$i]);

                    $query = 'INSERT INTO #__bl_match_events(e_id,player_id,match_id,ecount,minutes,t_id,eordering) VALUES('.$new_event.','.intval($plis[0]).','.$row->id.','.intval($_POST['e_countval'][$i]).','.floatval($_POST['e_minuteval'][$i]).','.intval($plis[1]).','.$eordering.')';
                    $this->db->setQuery($query);
                    $this->db->query();
                    $me_arr[] = $this->db->insertid();
                    if (in_array($new_event, $events_boxFields)) {
                        if (isset($event_box_data[intval($plis[0])][$new_event])) {
                            $event_box_data[intval($plis[0])][$new_event] += intval($_POST['e_countval'][$i]);
                        } else {
                            $event_box_data[intval($plis[0])][$new_event] = intval($_POST['e_countval'][$i]);
                        }
                    }
                } else {
                    $query = 'SELECT * FROM #__bl_match_events WHERE id='.intval($_POST['em_id'][$i]);
                    $this->db->setQuery($query);
                    $event_bl = $this->db->loadObjectList();
                    if (count($event_bl)) {
                        $query = 'UPDATE #__bl_match_events SET minutes="'.($_POST['e_minuteval'][$i]).'",ecount='.intval($_POST['e_countval'][$i]).',eordering='.$eordering.' WHERE id='.intval($_POST['em_id'][$i]);
                        $this->db->setQuery($query);
                        $this->db->query();
                        $me_arr[] = intval($_POST['em_id'][$i]);
                        
                        if (in_array($event_bl[0]->e_id, $events_boxFields)) {
                            if (isset($event_box_data[$event_bl[0]->player_id][$event_bl[0]->e_id])) {
                                $event_box_data[$event_bl[0]->player_id][$event_bl[0]->e_id] += intval($_POST['e_countval'][$i]);
                            } else {
                                $event_box_data[$event_bl[0]->player_id][$event_bl[0]->e_id] = intval($_POST['e_countval'][$i]);
                            }
                        }
                    }
                }
                ++$eordering;
            }
        }
        
        $query = 'SELECT t_type FROM #__bl_matchday WHERE id='.$row->m_id;
        $this->db->setQuery($query);

        $tt_type = $this->db->loadResult();
        
        if($tt_type == '3'){
            if($score1_prev != $row->score1 || $score2_prev != $row->score2){
                $query = 'SELECT knock_str FROM #__bl_matchday WHERE id = '.$row->m_id;
                $this->db->setQuery($query);
                $knock_str = $this->db->loadResult();
                
                $knock_str = unserialize($knock_str);
                for($intK=0;$intK<count($knock_str);$intK++){
                    //var_dump($knock_str[$intK]);
                    if($knock_str[$intK]){
                        $intV = 0;
                        foreach ($knock_str[$intK] as $mtch) {
                            if(in_array($row->id, $mtch['match_id'])){
                                $kyeIn = array_search($row->id, $mtch['match_id']);
                                $knock_str[$intK][$intV]['score1'][$kyeIn] = $row->score1;
                                $knock_str[$intK][$intV]['score2'][$kyeIn] = $row->score2;
                                
                            }
                            $intV++;
                        }
                    }
                    
                }
                $query = 'UPDATE #__bl_matchday SET knock_str="'.addslashes(serialize($knock_str)).'" WHERE id = '.$row->m_id;
                $this->db->setQuery($query);
                $this->db->query();
            }
        }
        
        
        /////////////
        
        
        $me_arr_t = array();
        if (isset($_POST['mevent_id']) && count($_POST['mevent_id'])) {
            for ($i = 0; $i < count($_POST['mevent_id']); ++$i) {
                if (intval($_POST['mevent_id'][$i])) {
                    $query = 'DELETE FROM #__bl_match_events WHERE match_id = '.$row->id.' AND e_id='.intval($_POST['mevent_id'][$i]);
        
                    $this->db->setQuery($query);
                    $this->db->query();
                    
                    if (($_POST['mevents1'][$i]) != '') {
                        $query = 'INSERT INTO #__bl_match_events(e_id,t_id,match_id,ecount,minutes,eordering) VALUES('.intval($_POST['mevent_id'][$i]).','.$row->team1_id.','.$row->id.','.intval($_POST['mevents1'][$i]).',"0",0)';
                        $this->db->setQuery($query);
                        $this->db->query();
                        $me_arr_t[] = $this->db->insertid();
                    }
                    if (($_POST['mevents2'][$i]) != '') {
                        $query = 'INSERT INTO #__bl_match_events(e_id,t_id,match_id,ecount,minutes,eordering) VALUES('.intval($_POST['mevent_id'][$i]).','.$row->team2_id.','.$row->id.','.intval($_POST['mevents2'][$i]).',"0",0)';
                        $this->db->setQuery($query);
                        $this->db->query();
                        $me_arr_t[] = $this->db->insertid();
                    }
                }
            }
        }    
        
        /*$eordering_t = 0;
        $me_arr_t = array();
        if (isset($_POST['new_teventid']) && count($_POST['new_teventid'])) {
            for ($i = 0; $i < count($_POST['new_teventid']); ++$i) {
                if (!intval($_POST['et_id'][$i])) {
                    $new_event = $_POST['new_teventid'][$i];
                    $query = 'INSERT INTO #__bl_match_events(e_id,t_id,match_id,ecount,minutes,eordering) VALUES('.$new_event.','.$_POST['new_tplayer'][$i].','.$row->id.','.intval($_POST['et_countval'][$i]).",'0',".$eordering.')';
                    $this->db->setQuery($query);
                    $this->db->query();
                    $me_arr_t[] = $this->db->insertid();
                } else {
                    $query = 'SELECT * FROM #__bl_match_events WHERE id='.intval($_POST['et_id'][$i]);
                    $this->db->setQuery($query);
                    $event_bl = $this->db->loadObjectList();
                    if (count($event_bl)) {
                        $query = 'UPDATE #__bl_match_events SET ecount='.intval($_POST['et_countval'][$i]).',eordering='.$eordering_t.' WHERE id='.intval($_POST['et_id'][$i]);
                        $this->db->setQuery($query);
                        $this->db->query();
                        $me_arr_t[] = intval($_POST['et_id'][$i]);
                    }
                }
                ++$eordering_t;
            }
        }
        */
        $query = 'DELETE FROM #__bl_match_events WHERE match_id = '.$row->id;
        if (count($me_arr)) {
            $query .= ' AND id NOT IN ('.implode(',', $me_arr).')';
        }
        if (count($me_arr_t)) {
            $query .= ' AND id NOT IN ('.implode(',', $me_arr_t).')';
        }
        $this->db->setQuery($query);
        $this->db->query();

    ////////////

        //-------extra fields-----------//
        if (isset($_POST['extraf']) && count($_POST['extraf'])) {
            foreach ($_POST['extraf'] as $p => $dummy) {
                $query = 'DELETE FROM #__bl_extra_values WHERE f_id = '.$_POST['extra_id'][$p].' AND uid = '.$row->id;
                $this->db->setQuery($query);
                $this->db->query();
                if ($_POST['extra_ftype'][$p] == '2') {
                    $query = 'INSERT INTO #__bl_extra_values(f_id,uid,fvalue_text) VALUES('.$_POST['extra_id'][$p].','.$row->id.",'".addslashes($_POST['extraf'][$p])."')";
                } else {
                    $query = 'INSERT INTO #__bl_extra_values(f_id,uid,fvalue) VALUES('.$_POST['extra_id'][$p].','.$row->id.",'".addslashes($_POST['extraf'][$p])."')";
                }
                $this->db->setQuery($query);
                $this->db->query();
            }
        }

        //-----SQUARD--------///

        $query = 'DELETE FROM #__bl_squard WHERE match_id = '.$row->id;
        $this->db->setQuery($query);
        $this->db->query();
        if (isset($_POST['t1_squard']) && count($_POST['t1_squard'])) {
            for ($i = 0; $i < count($_POST['t1_squard']); ++$i) {
                $new_event = $_POST['t1_squard'][$i];
                if (isset($_POST['squadradio1_'.$new_event]) && $_POST['squadradio1_'.$new_event]) {
                    if ($_POST['squadradio1_'.$new_event] == '1' || $_POST['squadradio1_'.$new_event] == '2') {
                        $main_squad = ($_POST['squadradio1_'.$new_event] == '1') ? 1 : 0;
                        $query = 'INSERT INTO #__bl_squard(match_id,team_id,player_id,mainsquard) VALUES('.$row->id.','.$row->team1_id.','.$new_event.",'".$main_squad."')";
                        $this->db->setQuery($query);
                        $this->db->query();
                    }
                }
            }
        }

        if (isset($_POST['t2_squard']) && count($_POST['t2_squard'])) {
            for ($i = 0; $i < count($_POST['t2_squard']); ++$i) {
                $new_event = $_POST['t2_squard'][$i];
                if (isset($_POST['squadradio2_'.$new_event]) && $_POST['squadradio2_'.$new_event]) {
                    if ($_POST['squadradio2_'.$new_event] == '1' || $_POST['squadradio2_'.$new_event] == '2') {
                        $main_squad = ($_POST['squadradio2_'.$new_event] == '1') ? 1 : 0;
                        $query = 'INSERT INTO #__bl_squard(match_id,team_id,player_id,mainsquard) VALUES('.$row->id.','.$row->team2_id.','.$new_event.",'".$main_squad."')";
                        $this->db->setQuery($query);
                        $this->db->query();
                    }
                }
            }
        }

            //subs in
        $query = 'DELETE FROM #__bl_subsin WHERE match_id='.$row->id;
        $this->db->setQuery($query);
        $this->db->query();
        if (isset($_POST['playersq1_id_arr']) && count($_POST['playersq1_id_arr'])) {
            for ($i = 0; $i < count($_POST['playersq1_id_arr']); ++$i) {
                $player_out = intval($_POST['playersq1_id_arr'][$i]);
                $player_in = intval($_POST['playersq1_out_id_arr'][$i]);
                $minutes = intval($_POST['minutes1_arr'][$i]);
                $query = 'INSERT INTO #__bl_subsin(match_id,team_id,player_in,player_out,minutes,season_id) VALUES('.$row->id.','.$row->team1_id.','.$player_in.','.$player_out.",'".$minutes."',".$season_id.')';
                $this->db->setQuery($query);
                $this->db->query();
            }
        }
        if (isset($_POST['playersq2_id_arr']) && count($_POST['playersq2_id_arr'])) {
            for ($i = 0; $i < count($_POST['playersq2_id_arr']); ++$i) {
                $player_out = intval($_POST['playersq2_id_arr'][$i]);
                $player_in = intval($_POST['playersq2_out_id_arr'][$i]);
                $minutes = intval($_POST['minutes2_arr'][$i]);
                $query = 'INSERT INTO #__bl_subsin(match_id,team_id,player_in,player_out,minutes,season_id) VALUES('.$row->id.','.$row->team2_id.','.$player_in.','.$player_out.",'".$minutes."',".$season_id.')';
                $this->db->setQuery($query);
                $this->db->query();
            }
        }

        //--

        $query = 'DELETE  FROM #__bl_mapscore WHERE m_id = '.$row->id;
        $this->db->setQuery($query);
        $this->db->query();
        if (isset($_POST['mapid']) && count($_POST['mapid'])) {
            for ($i = 0; $i < count($_POST['mapid']); ++$i) {
                $new_event = $_POST['mapid'][$i];
                if($_POST['t1map'][$i] != '' && $_POST['t1map'][$i] != ''){
                    $query = 'INSERT INTO #__bl_mapscore(m_id,map_id,m_score1,m_score2) VALUES('.$row->id.','.$new_event.','.intval($_POST['t1map'][$i]).','.intval($_POST['t2map'][$i]).')';
                    $this->db->setQuery($query);
                    $this->db->query();
                }
            }
        }
        
        //boxscore
        $query = "SELECT p.id
			            FROM #__bl_players as p, #__bl_players_team as s
			            WHERE s.confirmed='0' AND s.player_join='0' AND s.player_id = p.id
			            AND s.team_id = ".$row->team1_id.' AND s.season_id='.$season_id
                        .' ORDER BY p.first_name,p.last_name';
        $this->db->setQuery($query);
        $h_players = $this->db->loadObjectList();
        
        
        for($intA=0;$intA<count($h_players);$intA++){
           $insert_field = '';
           $insert_vals = '';
           $update_vals = '';
           $box_data = filter_input(INPUT_POST, 'boxstat_'.$row->team1_id.'_'.$h_players[$intA]->id, FILTER_DEFAULT, FILTER_REQUIRE_ARRAY);
           if(count($box_data)){
               foreach($box_data as $key=>$value){
                   $insert_field .= ',boxfield_'.intval($key);
                   $insert_vals .= ",".($value != ''?floatval($value):'NULL');
                   if($update_vals){
                       $update_vals .= ",";
                   }
                   $update_vals .= "boxfield_".intval($key)."=".($value != ''?floatval($value):'NULL');
               }
           }
           if (isset($event_box_data[$h_players[$intA]->id]) && count($event_box_data[$h_players[$intA]->id])) {
               foreach($event_box_data[$h_players[$intA]->id] as $box_event_id => $event_value) {
                   if (isset($event_box_fields[$box_event_id])) {
                        $insert_field .= ',boxfield_'.intval($event_box_fields[$box_event_id]);
                        $insert_vals .= ",".($event_value != ''? ($event_value): 'NULL');
                        if($update_vals){
                            $update_vals .= ",";
                        }
                        $update_vals .= "boxfield_".intval($event_box_fields[$box_event_id])."=".($event_value != ''? ($event_value):'NULL');
                   }
               }
           }
           
           $this->db->setQuery("SELECT id FROM #__bl_box_matches WHERE match_id={$row->id} AND player_id={$h_players[$intA]->id} AND team_id={$row->team1_id}");
           $dobl = $this->db->loadResult();

           if($dobl){
               if($update_vals){
                    $this->db->setQuery("UPDATE #__bl_box_matches SET $update_vals"
                       . " WHERE id={$dobl}");
                    $this->db->query();   
               }
           }else{
               $this->db->setQuery("INSERT INTO #__bl_box_matches(match_id,season_id,team_id,player_id".$insert_field.")"
                       . " VALUES({$row->id},{$season_id},{$row->team1_id},{$h_players[$intA]->id}".$insert_vals.")");
           
                $this->db->query(); 
           }
        }
       
        $query = "SELECT p.id
			            FROM #__bl_players as p, #__bl_players_team as s
			            WHERE s.confirmed='0' AND s.player_join='0' AND s.player_id = p.id
			            AND s.team_id = ".$row->team2_id.' AND s.season_id='.$season_id
                        .' ORDER BY p.first_name,p.last_name';
        $this->db->setQuery($query);
        $a_players = $this->db->loadObjectList();
        
        for($intA=0;$intA<count($a_players);$intA++){
           $insert_field = '';
           $insert_vals = '';
           $update_vals = '';
           $box_data = filter_input(INPUT_POST, 'boxstat_'.$row->team2_id.'_'.$a_players[$intA]->id, FILTER_DEFAULT, FILTER_REQUIRE_ARRAY);
           
           if(count($box_data)){
               foreach($box_data as $key=>$value){
                   $insert_field .= ',boxfield_'.intval($key);
                   $insert_vals .= ",".($value != ''?floatval($value):'NULL');
                   if($update_vals){
                       $update_vals .= ",";
                   }
                   $update_vals .= "boxfield_".intval($key)."=".($value != ''?floatval($value):'NULL');
               }
           }
           if (isset($event_box_data[$a_players[$intA]->id]) && count($event_box_data[$a_players[$intA]->id])) {
               foreach($event_box_data[$a_players[$intA]->id] as $box_event_id => $event_value) {
                   if (isset($event_box_fields[$box_event_id])) {
                        $insert_field .= ',boxfield_'.intval($event_box_fields[$box_event_id]);
                        $insert_vals .= ",".($event_value != ''? ($event_value): 'NULL');
                        if($update_vals){
                            $update_vals .= ",";
                        }
                        $update_vals .= "boxfield_".intval($event_box_fields[$box_event_id])."=".($event_value != ''? ($event_value):'NULL');
                   }
               }
           }
           
           $this->db->setQuery("SELECT id FROM #__bl_box_matches WHERE match_id={$row->id} AND player_id={$a_players[$intA]->id} AND team_id={$row->team2_id}");
           $dobl = $this->db->loadResult();
           if($dobl){
               if($update_vals){
                    $this->db->setQuery("UPDATE #__bl_box_matches SET $update_vals"
                       . " WHERE id={$dobl}");
                    $this->db->query();   
               }
           }else{
               $this->db->setQuery("INSERT INTO #__bl_box_matches(match_id,season_id,team_id,player_id".$insert_field.")"
                       . " VALUES({$row->id},{$season_id},{$row->team2_id},{$a_players[$intA]->id}".$insert_vals.")");
               $this->db->query();  
           }
       }
       
        
        

                //update season table
                if ($lt_type == 0) {
                    require_once JPATH_COMPONENT_SITE.DIRECTORY_SEPARATOR.'sportleague'.DIRECTORY_SEPARATOR.'sportleague.php';
                    classJsportPlugins::get('generateTableStanding', array('season_id' => $season_id));
                }
                
                
                
                //update player list
                require_once JPATH_COMPONENT_SITE.DIRECTORY_SEPARATOR.'sportleague'.DIRECTORY_SEPARATOR.'sportleague.php';
                classJsportPlugins::get('generatePlayerList', array('season_id' => $season_id));
                
                //fire matchonsave event
                classJsportPlugins::get('onMatchSave', array('match_id' => $row->id));
                if($score1_prev != $row->score1 || $score2_prev != $row->score2){
                    classJsportPlugins::get('onMatchScoreChange', array('match_id' => $row->id));
                }

        $this->_id = $row->id;
        
        //translation
        if(isset($_POST['translation']) && count($_POST['translation'])){
            $this->db->setQuery(
                    "DELETE FROM #__bl_translations WHERE jsfield='match_".$row->id."'"
                    );
            $this->db->query();
            foreach ($_POST['translation'] as $key => $value) {
                $value['match_descr'] = str_replace("\r\n", "", $value['match_descr']);
                $translation = json_encode($value);
                $translation = nl2br($translation);
                $translation = str_replace("\r\n", "", $translation);
                
                $this->db->setQuery(
                        "INSERT INTO #__bl_translations(jsfield,translation,languageID)"
                        ." VALUES('match_".$row->id."','".addslashes($translation)."','".$key."')"
                        );
                $this->db->query();
            }
        }
    }

    public function deleteMday($cid)
    {
        if (!JFactory::getUser()->authorise('core.delete', 'com_joomsport')) {
            return JError::raiseError(303, '');
        }
        if (count($cid)) {
            $cids = implode(',', $cid);
            $this->db->setQuery('DELETE FROM #__bl_matchday WHERE id IN ('.$cids.')');
            $this->db->query();
            $this->db->setQuery('DELETE FROM #__bl_match WHERE m_id IN ('.$cids.')');
            $this->db->query();
        }
    }

    public function getMdID()
    {
        if ($this->_id) {
            $query = 'SELECT m_id FROM #__bl_match WHERE id='.$this->_id;
            $this->db->setQuery($query);

            return $this->db->loadResult();
        }
    }
    public function getBoxStat($row){
        //box fields
        /*$barray_first = $barray_second = array();
        $query = 'SELECT * FROM #__bl_box_fields'
                .' WHERE parent_id = 0'
                . ' ORDER BY ordering,id';
        
        $this->db->setQuery($query);
        $boxes = $this->db->loadObjectList();
        for($intA=0;$intA<count($boxes); $intA++){
            $query = 'SELECT * FROM #__bl_box_fields'
                .' WHERE parent_id = '.intval($boxes[$intA]->id)
                . ' ORDER BY ordering,id';
        
            $this->db->setQuery($query);
            $boxes_child = $this->db->loadObjectList();
            if(count($boxes_child)){
                $barray_first[] = array($boxes[$intA], count($boxes_child));
                $barray_second[] = $boxes_child;
            }
        }
        $this->_lists['box1level'] = $barray_first;
        $this->_lists['box2level'] = $barray_second;*/
        
        $home_team = $row->team1_id;
        $away_team = $row->team2_id;
        $season_id = $this->s_id;
        
        $html = '';
        
        $this->db->setQuery('SELECT * FROM #__bl_box_fields WHERE parent_id="0" AND ftype="0" AND published="1" ORDER BY ordering,name') ;
        $complexBox = $this->db->loadObjectList();
        if(!count($complexBox)){
            $html .= JText::sprintf('BLBE_BOXSCORE_NORECORDS','<a href="index.php?option=com_joomsport&task=boxfields_list">','</a>');
            return $html;
        }
        $html .= '<h4>'.($this->_lists['teams1']).'</h4>';
        $res_html = '';
        
        $query = "SELECT cfg_value FROM #__bl_config WHERE cfg_name='boxExtraField'";
        $this->db->setQuery($query);

        $efbox = (int) $this->db->loadResult();
        
        $parentB = array();
        $parentInd = 0;
        for($intA=0;$intA<count($complexBox); $intA++){
            $complexBox[$intA]->extras = array();
            $childBox = array();
            if($complexBox[$intA]->complex == '1'){
                $this->db->setQuery('SELECT * FROM #__bl_box_fields WHERE parent_id="'.$complexBox[$intA]->id.'" AND published="1" AND ftype="0" ORDER BY ordering,name') ;
                $childBox = $this->db->loadObjectList();
                for($intB=0;$intB<count($childBox); $intB++){
                    $options = json_decode($childBox[$intB]->options,true);
                    $extras = isset($options['extraVals'])?$options['extraVals']:array();
                    $childBox[$intB]->extras = $extras;
                    if(count($extras)){
                        foreach($extras as $extr){
                            array_push($complexBox[$intA]->extras, $extr);
                        }
                    }
                }
                
                if(count($childBox)){
                    $parentB[$parentInd]['object'] = $complexBox[$intA];
                    $parentB[$parentInd]['childs'] = $childBox;
                    $parentInd++;
                }
            }else{
                $options = json_decode($complexBox[$intA]->options,true);
                $extras = isset($options['extraVals'])?$options['extraVals']:array();
                $complexBox[$intA]->extras =  $extras;
                $parentB[$parentInd]['object'] = $complexBox[$intA];
                $parentB[$parentInd]['childs'] = $childBox;
                $parentInd++;
            }
            
            
            
        }
        
        $th1 = '';
        $th2 = '';
        
        $all_players = $this->_lists['team1_players'];

        if($efbox){
            $this->db->setQuery('SELECT season_related FROM #__bl_extra_filds WHERE id="'.$efbox.'"') ;
            $season_related = $this->db->loadResult();
            
            $this->db->setQuery('SELECT id, sel_value as name FROM #__bl_extra_select WHERE fid="'.$efbox.'" ORDER BY eordering,sel_value', 'OBJECT') ;
            $simpleBox = $this->db->loadObjectList();
            for($intS=0;$intS<count($simpleBox);$intS++){ 
                 $query = "SELECT p.id as id,CONCAT(p.first_name,' ',p.last_name) as p_name
			            FROM #__bl_players as p, #__bl_players_team as s
                                    , #__bl_extra_values as ev 
			            WHERE s.confirmed='0' AND s.player_join='0' AND s.player_id = p.id
			            AND s.team_id = ".$home_team.' AND s.season_id='.$season_id
                                    ." AND ev.uid=p.id AND f_id={$efbox} AND ev.fvalue={$simpleBox[$intS]->id}"
                                    .($season_related?" AND ev.season_id=".$season_id:"")
                        .' ORDER BY p.first_name,p.last_name';
                $this->db->setQuery($query);
                $players = $this->db->loadObjectList();
                
                $th1=$th2='';
                $boxtd = array();
                for($intA=0;$intA<count($parentB);$intA++){
                    $box = $parentB[$intA];
                    $intChld = 0;
                    for($intB=0;$intB<count($box['childs']); $intB++){
                        if(!count($box['childs'][$intB]->extras) || in_array($simpleBox[$intS]->id, $box['childs'][$intB]->extras)){
                            $intChld++;
                            $th2 .= "<th>".$box['childs'][$intB]->name."</th>";
                            $boxtd[] =  $box['childs'][$intB]->id;
                        }
                    }

                    if(!count($box['object']->extras) || in_array($simpleBox[$intS]->id, $box['object']->extras)){

                        if($intChld){
                            $th1 .= '<th colspan="'.$intChld.'">'.$box['object']->name.'</th>';
                        }else{
                            $th1 .= '<th rowspan="2">'.$box['object']->name.'</th>';
                            $boxtd[] =  $box['object']->id;
                        }
                    }
                }
                $res_html_head = $simpleBox[$intS]->name;
                $res_html_body  = '';
                
                $res_html_head .= '<table class="jsBoxStatDIv">
                                <thead>
                                    <tr>
                                        <th rowspan="2">#</th>
                                        '.$th1.'
                                    </tr>
                                    <tr>
                                        '.$th2.'
                                    </tr>
                                </thead>
                                <tbody>';
                                    if(count($boxtd)){
                                        for($intPP=0;$intPP<count($players);$intPP++){
                                            $res_html_body .=  '<tr>';
                                            $res_html_body .=  '<td>';
                                            $player = ($players[$intPP]);
                                            $res_html_body .=  $player->p_name;
                                            $res_html_body .=  '</td>';
                                            $this->db->setQuery("SELECT * FROM #__bl_box_matches WHERE match_id={$row->id} AND team_id={$home_team} AND player_id={$player->id}");
                                            $player_stat = $this->db->loadObject();
                                            for($intBox=0;$intBox<count($boxtd);$intBox++){
                                                $boxfield = 'boxfield_'.$boxtd[$intBox];
                                                $res = isset($player_stat->{$boxfield})?$player_stat->{$boxfield}:'';
                                                $res_html_body .=  '<td><input data-inputboxtype="float" type="text" name="boxstat_'.$home_team.'_'.$player->id.'['.$boxtd[$intBox].']" value="'.($res).'" /></td>';
                                            }

                                            $res_html_body .=  '</tr>';
                                        }
                                    }
                              
                    if($res_html_body){    
                        $res_html .= $res_html_head.$res_html_body.'</tbody></table>'; 
                    }        

            }
        }else{
            $th1=$th2='';
            $boxtd = array();
            $players = $this->_lists['team1_players'];
            for($intA=0;$intA<count($parentB);$intA++){
                $box = $parentB[$intA];
                $intChld = 0;
                for($intB=0;$intB<count($box['childs']); $intB++){
                    $intChld++;
                    $th2 .= "<th>".$box['childs'][$intB]->name."</th>";
                    $boxtd[] =  $box['childs'][$intB]->id;
                    
                }

                if($intChld){
                    $th1 .= '<th colspan="'.$intChld.'">'.$box['object']->name.'</th>';
                }else{
                    $th1 .= '<th rowspan="2">'.$box['object']->name.'</th>';
                    $boxtd[] =  $box['object']->id;
                }
                
            }
                $res_html_head = $res_html_body  = '';
                $res_html_head .= '<table class="jsBoxStatDIv">
                                <thead>
                                    <tr>
                                        <th rowspan="2">#</th>
                                        '.$th1.'
                                    </tr>
                                    <tr>
                                        '.$th2.'
                                    </tr>
                                </thead>
                                <tbody>';
                                    if(count($boxtd)){
                                        for($intPP=0;$intPP<count($players);$intPP++){
                                            $res_html_body .=  '<tr>';
                                            $res_html_body .=  '<td>';
                                            $player = ($players[$intPP]);
                                            $res_html_body .=  $player->p_name;
                                            $res_html_body .=  '</td>';
                                            
                                            $this->db->setQuery("SELECT * FROM #__bl_box_matches WHERE match_id={$row->id} AND team_id={$home_team} AND player_id={$player->pid}");
                                            $player_stat = $this->db->loadObject();

                                            for($intBox=0;$intBox<count($boxtd);$intBox++){
                                                $boxfield = 'boxfield_'.$boxtd[$intBox];
                                                $res = isset($player_stat->{$boxfield})?$player_stat->{$boxfield}:'';
                                                $res_html_body .=  '<td><input data-inputboxtype="float" type="text" name="boxstat_'.$home_team.'_'.$player->pid.'['.$boxtd[$intBox].']" value="'.($res).'" /></td>';
                                            }

                                            $res_html_body .=  '</tr>';
                                        }
                                    }
                    if($res_html_body){    
                        $res_html .= $res_html_head.$res_html_body.'</tbody></table>'; 
                    }

        }
        if($res_html){
            $html .= $res_html;
        }else{
            if(count($all_players)){
                //$html .= JText::sprintf('BLBE_BOXSCORE_NORECORDS','<a href="index.php?option=com_joomsport&task=boxfields_list">','</a>');
            
            }else{
                $html .= JText::_('BLBE_BOXSCORE_ASSIGN_MESSAGE');
        
            }
        }
        //away
        
        $html .=  '<h4>'.($this->_lists['teams2']).'</h4>';
        $res_html = '';
        
        $th1 = '';
        $th2 = '';
        $all_players = $this->_lists['team2_players'];

        if($efbox){
            $this->db->setQuery('SELECT season_related FROM #__bl_extra_filds WHERE id="'.$efbox.'"') ;
            $season_related = $this->db->loadResult();
            
            $this->db->setQuery('SELECT id, sel_value as name FROM #__bl_extra_select WHERE fid="'.$efbox.'" ORDER BY eordering,sel_value', 'OBJECT') ;
            $simpleBox = $this->db->loadObjectList();
            for($intS=0;$intS<count($simpleBox);$intS++){ 
                 $query = "SELECT p.id as id,CONCAT(p.first_name,' ',p.last_name) as p_name
			            FROM #__bl_players as p, #__bl_players_team as s
                                    , #__bl_extra_values as ev
			            WHERE s.confirmed='0' AND s.player_join='0' AND s.player_id = p.id
			            AND s.team_id = ".$away_team.' AND s.season_id='.$season_id
                         ." AND ev.uid=p.id AND f_id={$efbox} AND ev.fvalue={$simpleBox[$intS]->id}"
                         .($season_related?" AND ev.season_id=".$season_id:"")
                        .' ORDER BY p.first_name,p.last_name';
                $this->db->setQuery($query);
                $players = $this->db->loadObjectList();$th1=$th2='';
                $boxtd = array();
                for($intA=0;$intA<count($parentB);$intA++){
                    $box = $parentB[$intA];
                    $intChld = 0;
                    for($intB=0;$intB<count($box['childs']); $intB++){
                        if(!count($box['childs'][$intB]->extras) || in_array($simpleBox[$intS]->id, $box['childs'][$intB]->extras)){
                            $intChld++;
                            $th2 .= "<th>".$box['childs'][$intB]->name."</th>";
                            $boxtd[] =  $box['childs'][$intB]->id;
                        }
                    }

                    if(!count($box['object']->extras) || in_array($simpleBox[$intS]->id, $box['object']->extras)){

                        if($intChld){
                            $th1 .= '<th colspan="'.$intChld.'">'.$box['object']->name.'</th>';
                        }else{
                            $th1 .= '<th rowspan="2">'.$box['object']->name.'</th>';
                            $boxtd[] =  $box['object']->id;
                        }
                    }
                }
                $res_html_head = $simpleBox[$intS]->name;
                $res_html_body  = '';
                $res_html_head .= '<table class="jsBoxStatDIv">
                                <thead>
                                    <tr>
                                        <th rowspan="2">#</th>
                                        '.$th1.'
                                    </tr>
                                    <tr>
                                        '.$th2.'
                                    </tr>
                                </thead>
                                <tbody>';
                                    if(count($boxtd)){
                                        for($intPP=0;$intPP<count($players);$intPP++){
                                            $res_html_body .= '<tr>';
                                            $res_html_body .= '<td>';
                                            $player = ($players[$intPP]);
                                            $res_html_body .= $player->p_name;
                                            $res_html_body .= '</td>';
                                            $this->db->setQuery("SELECT * FROM #__bl_box_matches WHERE match_id={$row->id} AND team_id={$away_team} AND player_id={$player->id}");
                                            $player_stat = $this->db->loadObject();

                                            for($intBox=0;$intBox<count($boxtd);$intBox++){
                                                $boxfield = 'boxfield_'.$boxtd[$intBox];

                                                $res = isset($player_stat->{$boxfield})?$player_stat->{$boxfield}:'';
                                                $res_html_body .= '<td><input type="text" data-inputboxtype="float" name="boxstat_'.$away_team.'_'.$player->id.'['.$boxtd[$intBox].']" value="'.($res).'" /></td>';
                                            }

                                            $res_html_body .= '</tr>';
                                        }
                                    }
                    if($res_html_body){    
                        $res_html .= $res_html_head.$res_html_body.'</tbody></table>'; 
                    }           

            }
        }else{
            $th1=$th2='';
            $boxtd = array();
            $players = $this->_lists['team2_players'];
            for($intA=0;$intA<count($parentB);$intA++){
                $box = $parentB[$intA];
                $intChld = 0;
                for($intB=0;$intB<count($box['childs']); $intB++){
                    $intChld++;
                    $th2 .= "<th>".$box['childs'][$intB]->name."</th>";
                    $boxtd[] =  $box['childs'][$intB]->id;
                    
                }

                if($intChld){
                    $th1 .= '<th colspan="'.$intChld.'">'.$box['object']->name.'</th>';
                }else{
                    $th1 .= '<th rowspan="2">'.$box['object']->name.'</th>';
                    $boxtd[] =  $box['object']->id;
                }
                
            }
                $res_html_body = $res_html_head  = '';
                $res_html_head .= '<table class="jsBoxStatDIv">
                                <thead>
                                    <tr>
                                        <th rowspan="2">#</th>
                                        '.$th1.'
                                    </tr>
                                    <tr>
                                        '.$th2.'
                                    </tr>
                                </thead>
                                <tbody>';
                                    if(count($boxtd)){
                                        for($intPP=0;$intPP<count($players);$intPP++){
                                            $res_html_body .= '<tr>';
                                            $res_html_body .= '<td>';
                                            $player = ($players[$intPP]);
                                            $res_html_body .= $player->p_name;
                                            $res_html_body .= '</td>';
                                            $this->db->setQuery("SELECT * FROM #__bl_box_matches WHERE match_id={$row->id} AND team_id={$away_team} AND player_id={$player->pid}");
                                            $player_stat = $this->db->loadObject();

                                            for($intBox=0;$intBox<count($boxtd);$intBox++){
                                                $boxfield = 'boxfield_'.$boxtd[$intBox];
                                                $res = isset($player_stat->{$boxfield})?$player_stat->{$boxfield}:'';
                                                $res_html_body .= '<td><input data-inputboxtype="float" type="text" name="boxstat_'.$away_team.'_'.$player->pid.'['.$boxtd[$intBox].']" value="'.($res).'" /></td>';
                                            }

                                            $res_html_body .= '</tr>';
                                        }
                                    }
                    if($res_html_body){    
                        $res_html .= $res_html_head.$res_html_body.'</tbody></table>'; 
                    } 
        }
        if($res_html){
            $html .=  $res_html;
        }else{
            if(count($all_players)){
                //$html .= JText::sprintf('BLBE_BOXSCORE_NORECORDS','<a href="index.php?option=com_joomsport&task=boxfields_list">','</a>');
            
            }else{
                $html .= JText::_('BLBE_BOXSCORE_ASSIGN_MESSAGE');
        
            }
            
        }
        return $html;
    }
}
