<?php
/*------------------------------------------------------------------------
# JoomSport Professional 
# ------------------------------------------------------------------------
# BearDev development company 
# Copyright (C) 2011 JoomSport.com. All Rights Reserved.
# @license - http://joomsport.com/news/license.html GNU/GPL
# Websites: http://www.JoomSport.com 
# Technical Support:  Forum - http://joomsport.com/helpdesk/
-------------------------------------------------------------------------*/
// No direct access.
defined('_JEXEC') or die;

require dirname(__FILE__).'/../models.php';

class tour_editJSModel extends JSPRO_Models
{
    public $_data = null;
    public $_lists = null;
    public $_mode = 1;
    public $_id = null;
    public function __construct()
    {
        parent::__construct();

        $mainframe = JFactory::getApplication();

        $this->getData();
    }

    public function getData()
    {
        $cid = JRequest::getVar('cid', array(0), '', 'array');
        JArrayHelper::toInteger($cid, array(0));
        $db = JFactory::getDBO();
        $row = new JTableTourn($db);
        $row->load($cid[0]);
        $this->_data = $row;
        $error = $this->db->getErrorMsg();
        if ($error) {
            return JError::raiseError(500, $error);
        }

        $published = ($row->id) ? $row->published : 1;
        $this->_lists['published'] = JHTML::_('select.booleanlist',  'published', 'class="inputbox"', $published, JText::_('JPUBLISHED'), JText::_('JUNPUBLISHED'));

        $type_single = array();
        $type_single[] = JHTML::_('select.option',  1, JText::_('BLBE_MENTEAMS'), 'id', 'name');
        $type_single[] = JHTML::_('select.option',  2, JText::_('BLBE_SELTOURNSING'), 'id', 'name');
        $this->_lists['t_single'] = JHTML::_('select.radiolist',   $type_single, 't_single', 'class="inputbox" size="1"', 'id', 'name', $row->t_single ? ($row->t_single + 1) : 1);

        $type_tourn[] = JHTML::_('select.option',  0, JText::_('BLBE_TOURTYPEMATCH'), 'id', 'name');
        $type_tourn[] = JHTML::_('select.option',  1, JText::_('BLBE_TOURNTYPERACING'), 'id', 'name');
        $this->_lists['tourn_type'] = JHTML::_('select.genericlist',   $type_tourn, 'tournament_type', 'class="inputbox" size="1"', 'id', 'name', $row->tournament_type);

        $this->_lists['post_max_size'] = $this->getValSettingsServ('post_max_size');
        $this->_lists['languages'] = $this->getLanguages();
        $this->_lists['translation'] = array();
        if(count($this->_lists['languages']) && $row->id){
            $this->_lists['translation'] = $this->getTranslation('tournament_'.$row->id);
        }
    }
    public function saveTourn()
    {
        if (!JFactory::getUser()->authorise('core.edit', 'com_joomsport')) {
            return JError::raiseError(303, '');
        }
        $db = JFactory::getDBO();
        $post = JRequest::get('post');

        $post['descr'] = JRequest::getVar('descr', '', 'post', 'string', JREQUEST_ALLOWRAW);
        $istlogo = JRequest::getVar('istlogo', 0, 'post', 'int');
        $row = new JTableTourn($db);
        --$post['t_single'];
        if (!$istlogo) {
            $post['logo'] = '';
        }
        if (isset($_POST['uplLogo'])) {
            $post['logo'] = $_POST['uplLogo'];
        }

        if (!$row->bind($post)) {
            JError::raiseError(500, $row->getError());
        }
        if (!$row->check()) {
            JError::raiseError(500, $row->getError());
        }
        // if new item order last in appropriate group
        if (!$row->store()) {
            JError::raiseError(500, $row->getError());
        }
        $row->checkin();
        $this->_id = $row->id;
        
        //translation
        if(isset($_POST['translation']) && count($_POST['translation'])){
            $db->setQuery(
                    "DELETE FROM #__bl_translations WHERE jsfield='tournament_".$row->id."'"
                    );
            $db->query();
            foreach ($_POST['translation'] as $key => $value) {
                $value['descr'] = str_replace("\r\n", "", $value['descr']);
                $translation = json_encode($value);
                $translation = nl2br($translation);
                $translation = str_replace("\r\n", "", $translation);
                
                $db->setQuery(
                        "INSERT INTO #__bl_translations(jsfield,translation,languageID)"
                        ." VALUES('tournament_".$row->id."','".addslashes($translation)."','".$key."')"
                        );
                $db->query();
            }
        }
        
        //die();
    }
}
